/**
 * Created by zhang on 2018/9/10.
 */
import BaseController from "../../common/base/base_controller";
let config = require("../../../config/config.js");
let logger = require('../../../logs/log_helper').logger;
import economicFacade from "../facade/economic_facade";

class EconomicController extends BaseController{
    async main(request, response) {
        let economicLibs = await economicFacade.findByCondition({},{info:0},false);
        let randerData = {
            title:'主要经济指标库',
            userAccount: request.session.managerData.username,
            userID: request.session.managerData.userID,
            economicLibs:economicLibs,
            layout: 'maintain/common/html/layout'
        };
        response.render("maintain/economic_lib/html/main", randerData);
    }
    async addLib(request, response){
        try {
            await economicFacade.addLib(request.body);
        }catch (error) {
            console.log(error);
        }
        response.redirect(request.headers.referer);
    }
    async findLib(request, response){
        let result={
            error:0
        };
        try {
            let data = request.body.data;
            data = JSON.parse(data);
            let conditions={ID:data.ID};
            let resultData = await economicFacade.findByCondition(conditions);
            result.data=resultData;
        }catch (err){
            console.log(err);
            result.error=1;
            result.message = err.message;
        }
        response.json(result);
    }
    async saveLib(request, response){
        let result={
            error:0
        };
        try {
            let data = request.body.data;
            data = JSON.parse(data);
            let resultData= await economicFacade.saveLib(data);
            result.data=resultData;
        }catch (err){
            console.log(err);
            result.error=1;
            result.message = err.message;
        }
        response.json(result);
    }
    async deleteLibByID(request,response){
        logger.info(`delete feeRateLib ${request.ip}`);
        let result={
            error:0
        };
        try {
            let data = request.body.data;
            data = JSON.parse(data);
            let resultData= await economicFacade.deleteLibByID(data.ID);
            result.data=resultData;
        }catch (err){
            console.log(err);
            result.error=1;
            result.message = err.message;
        }
        response.json(result);
    }
    async edit(request,response){
        //先取出替换库信息：
        let libID = request.params.libID;
        let economicLib = await economicFacade.findByCondition({'ID':libID});
        if(economicLib){
            let randerData = {
                title:'主要经济指标库',
                mainURL:'/economic/main',
                libName:economicLib.name,
                userAccount: request.session.managerData.username,
                userID: request.session.managerData.userID,
                originalInfo:JSON.stringify(economicLib.index),
                libID:libID,
                LicenseKey:config.getLicenseKey(process.env.NODE_ENV),
                layout: 'maintain/common/html/edit_layout'
            };
            response.render("maintain/economic_lib/html/edit", randerData);
        }else {
            response.redirect(request.headers.referer);
        }
    }
}

export default EconomicController;